#include "scenetree.h"
#include "resourcemanager.h"
#include <pipeline.h>

// Scene

SceneTree::SceneTree() :
    Scene(),
    m_skybox(NULL)
{
    m_simplepipeline = new SimplePipeline();
    m_simplepipeline->setClearColor(glm::vec3(0.1f, 0.4f, 0.25f));
}

SceneTree::~SceneTree()
{

}

void SceneTree::setMainCamera(CameraNode *camera)
{
    m_simplepipeline->setCamera(camera);
}

SceneIterator<Light*>* SceneTree::getLights()
{
    // TODO
    return NULL;
}

SceneIterator<GeometryNode*>* SceneTree::getGeometry()
{
    // TODO
    return NULL;
}

void SceneTree::update()
{
    m_root.update();
}

// Container Node

void ContainerNode::update()
{
    for(SceneNode* sn : m_children)
        sn->update();
}

void ContainerNode::addChild(SceneNode* node)
{
    if(node != NULL)
    {
        m_children.push_back(node);
        node->m_parent = this;
    }
}

void ContainerNode::removeChild(SceneNode* node)
{
    if(node != NULL)
    {
        for(auto it = m_children.begin(); it != m_children.end(); ++it)
        {
            if(*it == node)
            {
                m_children.erase(it);
                break;
            }
        }
    }
}

